/**********************************************************************



  Filename:  stl_adap.cpp

  Chapter:   E      Appendix F - STL

  Compiler:  Borland C++     Version 5.01      Summer 1998

  C++ for C Programmers, Edition 3     By Ira Pohl





********************************************************************/



//Pointer to class member.



//Using a function object minus<int>.

//Use of the function adaptor bind2nd.

#include <iostream>

#include <algorithm>

#include <functional>

#include <string>

using namespace std;



template <class ForwIter>

void print(ForwIter first, ForwIter last, const char* title)

{

   cout << title << endl;

   while (first != last)

		      cout << *first++ << '\t';

   cout << endl;

}



int main()

{

   int data[3] = { 9, 10, 11};



   print(data, data + 3, "Original values");

   transform(data, data + 3, data,

             bind2nd(times<int>(), 2));

   print(data, data + 3, "New values");

   int look; cin >> look;

}

