/**********************************************************************



  Filename:  stl_iadp.cpp

  Chapter:   7      Templates Generic Programming and STL

  Compiler:  Borland C++     Version 5.01      Summer 1998

  C++ for C Programmers, Edition 3     By Ira Pohl





********************************************************************/



#include <iostream>

#include <vector>

using namespace std;

//Use of the reverse iterator



template <class ForwIter>

void print(ForwIter first, ForwIter last, const char* title)

{

   cout << title << endl;

   while ( first != last)

      cout << *first++ << '\t';

   cout << endl;

}



int main()

{

   int     data[3] = { 9, 10, 11};

   vector<int> d(data, data + 3);

   vector<int>::reverse_iterator p = d.rbegin();



   print(d.begin(), d.end(), "Original");

   print(p, d.rend(), "Reverse");



   int look; cin >> look;

}

