/**********************************************************************



  Filename:  stl_sort.cpp

  Chapter:   7      Templates Generic Programming and STL

  Compiler:  Borland C++     Version 5.01      Summer 1998

  C++ for C Programmers, Edition 3     By Ira Pohl





********************************************************************/



#include <iostream>

#include <algorithm>

using namespace std;

//Use of the reverse iterator



template <class ForwIter>

void print(ForwIter first, ForwIter last, const char* title)

{

   cout << title << endl;

   while ( first != last)

      cout << *first++ << '\t';

   cout << endl;

}



//Using sort() from STL



const int N = 5;

int main()

{

   int    d[N], i, *e = d + N;



   for (i = 0; i < N; ++i)

      d[i] = rand();

   sort(d, e);

   for (i = 0; i < N; ++i)

      cout << d[i] << '\t';



   int look; cin >> look;

}

