/**********************************************************************



  Filename:  complex1.cpp

  Chapter:   1      Overview of C++ and Object Oriented Programming

  Compiler:  Borland C++     Version 5.01      Summer 1998

  C++ for C Programmers, Edition 3     By Ira Pohl





********************************************************************/



//An elementary implementation of type complex



#include <iostream>      //IO library

#include <string>        //string type



using namespace std;



class complex {

public:                   //universal access to interface

   void re_assign(double r) { real = r; }

   void im_assign(double im) { imaginary = im; }

   void print() const

      { cout << "(" << real << ","

             << imaginary << "i)" << endl; }

   friend complex operator+(complex, complex);

private:                  //restricted access to implementation

   double real, imaginary;

};



//overload +



complex operator+(complex x, complex y)

{

   complex t;



   t.real = x.real + y.real;

   t.imaginary = x.imaginary + y.imaginary;

   return t;

}



int main()

{

   complex x, y, z;



   x.re_assign(9.5);

   x.im_assign(-4.5);

   y.re_assign(4.2);

   y.im_assign(6.0);

   z = x + y;

   x.print();

   y.print();

   z.print();

   int look; cin >> look;

}

