/**********************************************************************



  Filename:  fibona2.c

  Chapter:   2      Native Types and Statements

  Compiler:  Borland C++     Version 5.01      Summer 1998

  C++ for C Programmers, Edition 3     By Ira Pohl





********************************************************************/



//Idiomatically correct C++

//Fibonacci series incompatible with C

//This code follows the rule of smallest enclosing scope



unsigned fibonacci(unsigned n)

{

   unsigned sum = 0;

   //Borland won't compile this but GNU will



   for (unsigned i = 0, f0 = 0, f1 = 1; i < n - 1; ++i){

      sum = f0 + f1;

      f0 = f1;

      f1 = sum;

   }

   if (n > 1)

       return sum;

   else

       return n;

}



/* Print Fibonacci numbers and quotients. */



#include   <stdio.h>



#define   LIMIT   46



main()

{

   unsigned  n = 2;



   printf("\nEnter a number greater than 1 for fibonacci: ");

   scanf("%d", &n);

   while (n > 1) {

      printf("for %ld, the fibonacci number is %ld\n", n, fibonacci(n));

      printf("\nEnter a number greater than 1 for fibonacci: ");

      scanf ("%d", &n);

   }

}

