/**********************************************************************



  Filename:  mutable.cpp

  Chapter:   4      Classes

  Compiler:  Borland C++     Version 5.01      Summer 1998

  C++ for C Programmers, Edition 3     By Ira Pohl





********************************************************************/



#include <iostream>

#include <string>

using namespace std;

//class with mutable members



class person {

public:

   person(const char* pname, int page, unsigned long ssno) :

          age(page), soc_sec(ssno)

		 { name = new char [ (strlen(pname)+ 1) ];

			strcpy(const_cast<char*>(name), pname); }

   void bday() { ++age; }



	void print() const { cout << name << " is " << age

							  << " years old. SSN = "

							  << soc_sec << endl; }

private:

   const char*    name;

   mutable int    age;        //always modifiable

   unsigned long  soc_sec;

};



int main()

{

 	const

   person ira("ira pohl", 38, 1654);



	ira.print();

	ira.bday();

   ira.print();             //okay, ira.age is mutable

   int look; cin >> look;

}

