/**********************************************************************



  Filename:  nested.cpp

  Chapter:   4      Classes

  Compiler:  Borland C++     Version 5.01      Summer 1998

  C++ for C Programmers, Edition 3     By Ira Pohl





********************************************************************/



#include <iostream>

//using namespace std;



char  c;             //external scope  ::c



class X {            //outer class declaration  X::

public:

   char  c;          //X::c

   friend ostream& operator<<(ostream& out, X xc);

   class Y {         //inner class declaration  X::Y::

      public:

         void foo(char e) { X t; ::c = t.X::c = c = e; }

         friend ostream& operator<<(ostream& out, Y yc);

      private:

         char  c;       //X::Y::c

   };

};



ostream& operator<<(ostream& out, X xc)

{

   return (out << "  X::c = " << xc.c << "  ");

}





ostream& operator<<(ostream& out, Y yc)

{

   return (out << "  Y::c = " << yc.c << "  ");

}



int main()

{

   X xclass;

   X::Y yclass;



   c = 'A';      // external to 'A'

   cout << c << xclass << yclass << endl;

   yclass.foo('D');   // set Y::c and ::c to D

   cout << c << xclass << yclass << endl;



   int look; cin >> look;

}

